#!/bin/sh

# This example assumes that you
# are using a JVM called `java' (e.g., Sun's jdk)
# and that `jmangle' is in your CLASSPATH.
# The `javap' program is used to decompile
# the class files

# If you are using UNIX you can execute this file, 
# if you are using Windows, see README.bat, else
# run the commands below by hand in a shell 

# Let's decompile the java file
echo
cd classes
javap -s -l -private helloworld
cd ..

# Classes to be mangled MUST be in the CLASSPATH
CLASSPATH=${CLASSPATH}:.:./classes
export CLASSPATH

# This is a very simple example where
# a single class file is mangled. The
# class names are not mangled (by default)
# but method and field names are mangled.

# Jmangle will read the classes in the 
# directory `classes' and put the mangled
# class files into `mangled_classes'

# Using +verbose with a `-' will write
# detailed messages to System.out. The
# +map with a `-' writes the mapping
# from original symbols to mangled symbols.

echo
java -noclassgc jmangle +verbose - +map - classes mangled_classes

# to confirm the mangling use javap to examine the class file

echo
cd mangled_classes
javap -s -l -private helloworld
cd ..

# keep sure it works after mangling
echo
cd mangled_classes
java helloworld
cd ..
