/**
  @author Bharath Raj Rao
          brr@cat.syr.edu
 
Permission is granted to copy and modify this file as long as this message
including my name and email address is preserved.
 
No warranties. Use at your own risk. (Hey! we live in a litigious world!)
*/

import java.net.*;
import brr.net.*;
import brr.util.*;
import java.io.*;


public class Auditor {

    public Auditor(Socket s, String remotehost, int port) throws IOException {
	Protocol protocol = 
		new Protocol(s.getInputStream(), s.getOutputStream());
        protocol.setDefaultProtocolHandler(new Audit(remotehost, port));
        protocol.setTimeOut(500);
        protocol.start();
    }

    public static void main(String argv[]) throws IOException,
						  SocketException {
        ServerSocket ss;
        String remotehost = "amaran.cat.syr.edu";
        int PROXY_PORT = 9000;
        int PORT = 80;
 
        if (argv.length > 0) remotehost = argv[0];
        if (argv.length > 1) PORT = Integer.parseInt(argv[1]);
        if (argv.length > 2) PROXY_PORT = Integer.parseInt(argv[2]);
 
        ss = new ServerSocket(PROXY_PORT);

        while (true) {
           new Auditor(ss.accept(), remotehost, PORT);
        }
    }

};

class Audit extends ProtocolHandler {
    Socket s = null;
    int BUFSIZE = 32*1024;
    byte[] buf = new byte[BUFSIZE];
    InputStream cis, sis;
    PrintStream cos, sos;
    String remotehost;
    int port;
    
    public Audit(String remotehost, int port) {
        this.remotehost = remotehost; this.port = port;
    }

    public void run() {
        try {
	    cis = getInputStream();
	    cos = new PrintStream(getOutputStream());
        
            // open socket to target server
	    s = new Socket(remotehost, port);
            sis = s.getInputStream();
            sos = new PrintStream(s.getOutputStream());

        } catch(Exception e) { 
	    // Bitch about the error
	    System.out.println("Err getting socket or something");
	    return;
	}

        int amtread = 0;
        try {
	    // pass request to server
	    sos.println(getRequest());

	    // do we have anymore in request?
            if ( cis.available() > 0 ) {
            	amtread = cis.read(buf);
 		sos.write(buf,0, amtread); 

		// copy to System.out
	        System.out.println(getRequest());
                System.out.write(buf, 0, amtread);
                System.out.flush();
            } 
        } catch(IOException x) { cleanup(); }

        int pass = 0;
	try {
            while(true) {
		// give some time for reply.
		try { sleep(100); } catch(Exception e) { }
		int howmuch;
                if ( (howmuch = sis.available()) > 0) {
	            amtread = sis.read(buf); 
		    // pass on to client
		    cos.write(buf, 0, amtread); cos.flush(); 
		    pass = 0;

    // Handle the server's Reply. Actually A seperate
    // protocol class could be used here, which would interpret the replies. 
    // Example: send text to window, Images to display etc.
    // For HTTP, we could do like: 
    //   Protocol p = new Protocol(sis, cos);
    //   p.setProtocolHandler("Content-Type: text/html", new htmlHandler());
    //   p.setProtocolHandler("Content-Type: image/jpeg", new jpegHandler());
    //
    // But since this is a generic Auditor, we simply dump to System.out;

		    System.out.write(buf, 0, amtread); System.out.flush();
                    if ( amtread < 0 ) { cleanup(); }
                }
		// split the wait time over some # passes
		// so that we dont wait more than necessary
		if ( howmuch == 0 && ++pass > 5) { cleanup(); }
	    }
        } catch(Exception x) { 
	    cleanup();
 	}
    }

    private void cleanup() {
        System.out.flush();
	try {
	    // Close connection to target server
	    s.close(); 
	} catch (IOException e) {}
	this.stop();
   }
};

