/** @(#)LoaderApplet.java
  @author Bharath Raj Rao
          brr@cat.syr.edu
 
Permission is granted to copy and modify this file as long as this message
including my name and email address is preserved.
 
No warranties. Use at your own risk. (Hey! we live in a litigious world!)

*/
package brr.applet;

import java.awt.*;
import java.net.*;
import brr.awt.*;
import brr.net.*;
import java.applet.*;

/**
This Applet presents a FlyButton and creates a new instance of the target 
class (set through a parameter) every time the FlyButton is clicked.
The setLoader and init methods are called if the class implements
brr.net.Loadable interface.

<p>
<applet code=brr.applet.LoaderApplet width=100 height=50>
<param name=class value=brr.applet.examples.LoaderExample>
<param name=message value=Regular>
<param name=image value=images/blue-ball.gif>
</applet>
<p>Source: <a href="brr/applet/examples/LoaderExample.java">LoaderExample.java</a><p>
<applet code=brr.applet.LoaderApplet width=100 height=50>
<param name=class value=brr.net.examples.LoadableExample>
<param name=message value=Loadable>
<param name=image value=images/green-ball.gif>
</applet>
<p>Source: <a href="brr/applet/examples/LoaderExample.java">LoaderExample.java</
a><p>

@see brr.net.Loadable
*/

public class LoaderApplet extends Applet implements Runnable {
    TextPanel bs;
    Class cl;
    boolean loaded = false;
    String loadName = null;
    Image img;
    Frame f;
    FlyButton ib; 

    public void run() {
	try {
 	    cl = Class.forName(loadName);
	    bs.setText( "Initializing...");
	    loaded = true;
	    bs.setText("done...");
	} catch (Exception e) {e.printStackTrace(); }
	remove(bs);
	try {
	img = getImage(new URL(getDocumentBase(), getParameter("image")));
	} catch(Exception e) { }
	ImagePanel ip = new ImagePanel(img, false);
	TextPanel tp = new TextPanel(getParameter("message"));
	ib = new FlyButton(ip, tp);
	ib.setFont(new Font("Helvetica", Font.BOLD, 12));
	ib.setFlyButton(false);
	add("Center",ib);
	repaint();
    }

    public void init() {
	setLayout(new BorderLayout());
	add(bs = new TextPanel("Loading..."));
	loadName = getParameter("class");
	new Thread(this).start();
    }

    public boolean action(Event e, Object arg) {
	if (e.target instanceof FlyButton) {
	    try {
		Object l = cl.newInstance();
		// if the class does not implement Loadable,
		//    a ClassCastException occurs, which will be 
		//    caught and ignored. Else we proceed with the
		//    rest of the interface.
		((Loadable)l).setLoader(this);
		((Loadable)l).init();
	    } catch (Exception x) { x.printStackTrace(); return true; }
  	}
	return true;
    }

};


