/** @(#)Pipe.java	97 Aug 8
  @author Bharath Raj Rao
          brr@cat.syr.edu
 
Permission is granted to copy and modify this file as long as this message
including my name and email address is preserved.
 
No warranties. Use at your own risk. (Hey! we live in a litigious world!)

*/

package brr.io;

import java.io.*;
/** 
   A Pipe continuously waits on an inputStream and pumps whatever comes in into
   an OutputStream. This is done on a seperate Thread.

   Check out this simple talk program: 
	<a href="brr/io/examples/Talk.java">Talk.java</a>
*/

public class Pipe extends Thread {
    InputStream is;
    OutputStream os;

    protected int BUFSIZE = 1024;
    protected byte buf[] = new byte[BUFSIZE];

    /** Create a new Pipe. 
	@param is the pipe reads this Stream for input
	@param os the pipe writes the contents of <tt>is</tt> to this stream
    */
    public Pipe(InputStream is, OutputStream os) {
	this.is = is; this.os = os;
    }

    /** Set the buffer.
	@param buf the new buffer
    */
    protected void setBuffer(byte[] buf) {
	this.buf = buf;
    }

    public void run() {
	try {
	    while(true) {
		if (is.available() > 0) {
	    	    int read = is.read(buf);
	    	    os.write(buf, 0, read);
		} else {
	    	    try { Thread.sleep(100);} catch (Exception e) { }
		}
	    }
	} catch (IOException iox) { }
    }
};
